<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Dashboard Supervisión Mantenimiento</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>
          Dashboard Supervisión Mantenimiento -
          {{ this.nombreSupervisor }}
        </strong>
      </div>
    </div>
    <!-- Contenido -->
    <div class="contSecc">
      <div class="contenedorPrincipal">
        <v-row>
          <v-col>
            <div class="titSec">Descargar Informe de Territorio</div>
            <div style="margin: 25px 10px 50px 10px">
              <v-btn color="primary" dark @click="downExcel()" class="btnDisabled">
                <strong style="fond-size: 16px; color: #000">Descargar a Excel</strong>
              </v-btn>
            </div>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :md="6" class="pl-8">
            <div class="titSec">
              Cobertura {{ periodo.periodicidad }} de supervisiones
            </div>
            <div class="gris">
              <div style="height: 20"></div>

              <GraficaMediaCircularSupMto
                ref="mediaCircular"
                :name_id="valores1.filtros.name_id"
              />
              <GraficaBarraHorizontalSupMto
                hidden="true"
                ref="barraHorizontal"
                :name_id="valores2.filtros.name_id"
              />

              <Semaforo />
            </div>
          </v-col>
          <v-col :cols="12" :md="6" class="pr-8">
            <div class="titSec">
              Comparativa de cobertura semana actual vs semanas anteriores
            </div>
            <div class="gris">
              <GraficaBarrasComparativaSemanaSupMto
                ref="barraComparativaSemana"
                :name_id="valores3.filtros.name_id"
              />
            </div>
          </v-col>
        </v-row>
        <div class="titSec">Supervisiones del {{ periodo.periodo }}</div>
        <v-card>
          <TablaUsuariosSemanalesSupMtoCoordinador ref="tablaUsuariosSemanales" />
        </v-card>
      </div>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>

<script>
import store from "@/store";
import axios from "axios";
const serviceCommons = store.state.serviceCommons;
const periodoSupervisionMtto = store.state.periodoSupervisionMtto;
import GraficaMediaCircularSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaMediaCircularSupMto.vue";
import GraficaBarraHorizontalSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaBarraHorizontalSupMto.vue";
import GraficaBarrasComparativaSemanaSupMto from "@/views/secure/supervision-mantenimiento/dashboard/componentes/GraficaBarrasComparativaSemanaSupMto.vue";
import TablaUsuariosSemanalesSupMtoCoordinador from "@/views/secure/supervision-mantenimiento/coordinador/componentes/TablaUsuariosSemanalesSupMtoCoordinador.vue";
import Semaforo from "@/views/secure/supervision-mantenimiento/dashboard/componentes/Semaforo.vue";
import FileSaver from "file-saver";

export default {
  components: {
    GraficaMediaCircularSupMto,
    GraficaBarraHorizontalSupMto,
    GraficaBarrasComparativaSemanaSupMto,
    TablaUsuariosSemanalesSupMtoCoordinador,
    Semaforo,
  },
  name: "supervision_mantenimiento_dasboard_supervisor_coordinador",
  data() {
    return {
      periodo: {},
      idSupervisor: 0,
      nombreSupervisor: "",
      programadasTotales: 0,
      programadasSemana: 0,
      realizadasDia: 0,
      colores: ["#ff0000", "#ffcd00", "#19d228"],
      rangos: ["0,50", "51,89", "90,100"],
      objetoRangos: null,
      methodsSemaforo: null,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_dashboard_coordinador",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Territorio",
          disabled: true,
          exact: true,
          to: {
            name: "supervision_mantenimiento_dashboard_territorio_coordinador",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Supervisor",
          disabled: true,
        },
      ],

      fechasTrimestral: {
        territorio: 0,
        fechaInicio: "",
        fechaFin: "",
      },
      datosTerritorio: {
        territorio: "",
        idTerritorio: 0,
        responsable: "",
        valueTrimestre: 0,
        targetTrimestre: 0,
        valueAldia: 0,
        targetAldia: 0,
        rangoSemanas: null,
      },
      paramsNivel_2: "",
      valores1: {
        filtros: {
          name_id: "mediaCircular",
          value: 0,
          target1: 0,
          target2: 0,
          datos: [
            "Supervisiones del territorio realizadas al trimestre",
            "Supervisiones programadas al trimestre",
          ],
          styleObject: {
            width: "100%",
            height: "310px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
      valores2: {
        filtros: {
          value: 0,
          target: 0,
          categoria: "Categoria",
          name_id: "barraHorizontal",
          datos: [
            "Supervisiones realizadas al dia de hoy",
            "Supervisiones programadas al dia de hoy",
          ],
          styleObject: {
            width: "50%",
            height: "105px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
      valores3: {
        filtros: {
          value: 0,
          target: 0,
          categoria: "",
          name_id: "barraComparativaSemana",
          datos: [],
          styleObject: {
            width: "100%",
            height: "410px",
            margin: "auto",
          },
          rColores: this.colores,
          rCalf: this.rangos,
        },
      },
    };
  },
  methods: {
    iniciaGrafica() {
      //Valores de Odometro
      this.valores1.filtros.value = this.realizadasDia;
      this.valores1.filtros.target1 = this.programadasTotales;
      this.valores1.filtros.target2 = this.programadasSemana;
      this.valores1.filtros.rColores = this.colores;
      this.valores1.filtros.rCalf = this.rangos;
      this.$refs.mediaCircular.setValores(this.valores1.filtros);

      //Gráfica Semanal
      //this.cargaServiciosSemanal();
    },
    cargaSemanaUsuario() {
      let url = "/asignacion-mtto/secure/get/semanaUsuario";
      axios
        .post(url, this.fechasTrimestral)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              var data = response.data.data;
              console.log("Completo " + JSON.stringify(data));
              data = data.filter((item) => item.idUsuario == this.idSupervisor);
              console.log(
                "Datos del usuario " + this.idSupervisor + " -- " + JSON.stringify(data)
              );
              this.getConteoOdometro(data);
              this.getConteoBarras(data);
              this.nombreSupervisor = data[0].nombreResponsable;

              console.log("Llamando Set Valores:" + this.rangos);

              this.$refs.tablaUsuariosSemanales.setValores(
                data,
                this.fechasTrimestral.fechaInicio,
                this.fechasTrimestral.fechaFin,
                this.paramsNivel_2
              );
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    downExcel() {
      //DATA PARA DESCARGAR
      let objAdd = {
        fechaInicio: this.fechasTrimestral.fechaInicio,
        fechaFin: this.fechasTrimestral.fechaFin,
        territorio: this.datosTerritorio.idTerritorio,
      };

      axios
        .post("/asignacion-mtto/secure/get/reporteProgramadas", objAdd)
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              console.log(JSON.stringify(response.data.data));

              const dataFinal = this.crearInfoExcel(response.data.data);

              axios({
                method: "post",
                url: "/json/convert/secure/array/excel",
                responseType: "blob",
                data: dataFinal,
              })
                .then((response) => {
                  //console.log("La data:" + response.data)

                  if (response.headers["content-type"] !== "application/json") {
                    FileSaver.saveAs(response.data, response.headers["file-name"]);
                  }
                })
                .catch((error) => {
                  console.log(error);
                })
                .finally(function () {});

              if ("undefined" == typeof response.data.data) {
                alert("FALLO MORTAL");
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    crearInfoExcel(data) {
      let datos = data.filter((item) => item.idUsuario == this.idSupervisor);

      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["TERRITORIO", "territorio"],
        ["ZONA", "zona"],
        ["CECO", "idCeco"],
        ["NOMBRE_CECO", "nombreCeco"],
        ["USUARIO", "idUsuario"],
        ["NOMBRE_USUARIO", "nombreUsuario"],
        ["ESTATUS", "estatus"],
        ["FECHA_PROGRAMADA", "fechaProgramada"],
        //["FECHA_REALIZADA", "fechaRealizada"]
      ];
      for (var i = 0; i < datos.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          let instrucc =
            "ass." +
            fields[j][0] +
            " = typeof(datos[i]." +
            fields[j][1] +
            ") == 'undefined' ? '' : " +
            "datos[i]." +
            fields[j][1];
          eval(instrucc);
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    setSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getConteoOdometro(data) {
      Date.prototype.getWeekNumber = function () {
        var d = new Date(Date.UTC(this.getFullYear(), this.getMonth(), this.getDate()));
        var dayNum = d.getUTCDay() || 7;
        d.setUTCDate(d.getUTCDate() + 4 - dayNum);
        var yearStart = new Date(Date.UTC(d.getUTCFullYear(), 0, 1));
        return Math.ceil(((d - yearStart) / 86400000 + 1) / 7);
      };

      var semanaActual = new Date().getWeekNumber();

      var programadasTotales = 0;
      var programadasSemana = 0;
      var realizadasDia = 0;

      data.forEach((element) => {
        programadasTotales += element.conteoProgramadas;
        realizadasDia += element.conteoRealizadas;

        if (element.semana <= semanaActual) {
          programadasSemana += element.conteoProgramadas;
        }
      });

      this.programadasTotales = programadasTotales;
      this.programadasSemana = programadasSemana;
      this.realizadasDia = realizadasDia;

      this.iniciaGrafica();
    },
    getConteoBarras(data) {
      this.valores3.filtros.datos = [];
      data.forEach((element) => {
        var elem = [];

        elem = [
          {
            semana: element.semana,
            programacion: element.conteoProgramadas,
            realizado: element.conteoRealizadas,
          },
        ];
        this.valores3.filtros.datos = this.valores3.filtros.datos.concat(elem);
      });
      this.$refs.barraComparativaSemana.setValores(this.valores3.filtros);
    },
  },
  mounted() {
    this.$root.$on("rangoloaded", this.setSemaforo);
    this.cargaSemanaUsuario();
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  created() {
    this.periodo = periodoSupervisionMtto;
    this.valores1.filtros.datos[0] =
      "Supervisiones del territorio realizadas al " + this.periodo.periodo;
    this.valores1.filtros.datos[1] =
      "Supervisiones programadas al " + this.periodo.periodo;
    if (this.$route.params.parametros) {
      let parametros = this.serviceCommons.base64ToObject(this.$route.params.parametros);
      this.fechasTrimestral.fechaInicio = parametros.fechaInicio;
      this.fechasTrimestral.fechaFin = parametros.fechaFin;
      this.fechasTrimestral.territorio = parametros.idTerritorio;
      this.datosTerritorio.territorio = parametros.territorio;
      this.datosTerritorio.idTerritorio = parametros.idTerritorio;
      this.datosTerritorio.responsable = parametros.responsable;
      this.colores = JSON.parse(parametros.colores);
      this.idSupervisor = parametros.idSupervisor;
    }
    let paramsNivel_2_ = {
      fechaInicio: this.$route.params.fechaInicio,
      fechaFin: this.$route.params.fechaFin,
      idTerritorio: this.$route.params.idTerritorio,
      territorio: this.$route.params.territorio,
      responsable: this.$route.params.responsable,
    };
    this.paramsNivel_2 = JSON.stringify(paramsNivel_2_);
    console.log("Creado this-paramsNivel-2:" + this.paramsNivel_2);
    console.log("ValueTrimestre de URL:" + this.$route.params.valueTrimestre);
  },
};
</script>
